local debugger_get_output_rules = function(node)
	local rules = {{x = 0, y = 0, z = 1}}
	for i = 0, node.param2 do
		rules = mesecon:rotate_rules_left(rules)
	end
	return rules
end

local debugger_get_input_rules = function(node)
	local rules = {{x = 0, y = 0, z = -1}}
	for i = 0, node.param2 do
		rules = mesecon:rotate_rules_left(rules)
	end
	return rules
end

local nodebox = {
	type = "fixed",
	fixed = 	{{ -6/16, -8/16, -6/16, 6/16, -7/16, 6/16 },
			 { -4/16, -7/16, -2/16, -3/16, 0, 2/16 },
			 { -8/16, -8/16, -1/16, -6/16, -7/16,   1/16 },
			 {  6/16, -8/16, -1/16,  8/16, -7/16,   1/16 }}
}

minetest.register_node("digiline_debugger:debugger", {
	description = "Digiline Debugger",
	drawtype = "nodebox",
	tiles = {"default_wood.png"},
	groups = {snappy=2},
	on_construct = function (pos)
		meta = minetest.env:get_meta(pos)
		meta:set_string("formspec", "size[9,2.5]"..
			"field[0.256,-0.2;9,2;channel;Channel:;default]"..
			"field[0.256, 1;9,2;msg;Message:;]"..
			"button_exit[3.5,1;2,3;program;Send]")
	end,
	on_receive_fields = function (pos, formanme, fields)
		local rules = debugger_get_output_rules(minetest.env:get_node(pos))
		digiline:receptor_send(pos, rules, fields.channel, fields.msg)
	end,
	node_box = nodebox,
	paramtype = "light",
	paramtype2 = "facedir",
	digiline =
	{
		receptor = 
		{
			rules = debugger_get_output_rules
		},
		effector =
		{
			rules = debugger_get_input_rules,
			action = function (pos, node, channel, msg)
				print("Channel "..channel..": ".."'"..msg.."'")
			end
		}
	}
})
