minetest.register_node("piston:normal", {
	tile_images = {"piston_tb.png", "piston_tb.png", "piston_side.png", "piston_side.png", "piston_side.png", "piston_side.png"},
	inventory_image = minetest.inventorycube("piston_tb.png", "piston_side.png", "piston_side.png"),
	material = minetest.digprop_stonelike(0.5),
})

minetest.register_node("piston:sticky", {
	tile_images = {"piston_tb.png", "piston_tb.png", "piston_sticky_side.png", "piston_sticky_side.png", "piston_sticky_side.png", "piston_sticky_side.png"},
	inventory_image = minetest.inventorycube("piston_tb.png", "piston_sticky_side.png", "piston_sticky_side.png"),
	material = minetest.digprop_stonelike(0.5),
})

minetest.register_craft({
	output = 'node "piston:normal" 2',
	recipe = {
		{'node "default:wood"', 'node "default:wood"', 'node "default:wood"'},
		{'node "default:cobble"', 'craft "default:steel_ingot"', 'node "default:cobble"'},
		{'node "default:cobble"', 'node "jeija:mesecon_off"', 'node "default:cobble"'},
	}
})

minetest.register_craft({
	output = 'node "piston:sticky" 1',
	recipe = {
		{'craft "jeija:glue"'},
		{'node "piston:normal"'},
	}
})

function mesecon:piston_get_direction(pos)
	getactivated=0
	local direction = {x=0, y=0, z=0}
	local lpos=pos

	getactivated=getactivated+mesecon:is_power_on(lpos,  0,  0, -1)
	getactivated=getactivated+mesecon:is_power_on(lpos,  0, -1, -1)
	getactivated=getactivated+mesecon:is_power_on(lpos,  0,  1, -1)

	if getactivated>0 then direction.z=1 return direction end

	getactivated=getactivated+mesecon:is_power_on(lpos,  0,  1,  1)
	getactivated=getactivated+mesecon:is_power_on(lpos,  0, -1,  1)
	getactivated=getactivated+mesecon:is_power_on(lpos,  0,  0,  1)

	if getactivated>0 then direction.z=-1 return direction end

	getactivated=getactivated+mesecon:is_power_on(lpos,  1,  0,  0)
	getactivated=getactivated+mesecon:is_power_on(lpos,  1,  1,  0)
	getactivated=getactivated+mesecon:is_power_on(lpos,  1, -1,  0)

	if getactivated>0 then direction.x=-1 return direction end

	getactivated=getactivated+mesecon:is_power_on(lpos, -1,  1,  0)
	getactivated=getactivated+mesecon:is_power_on(lpos, -1, -1,  0)
	getactivated=getactivated+mesecon:is_power_on(lpos, -1,  0,  0)
	if getactivated>0 then direction.x=1 return direction end
	return direction
end

function mesecon:piston_get_direction_sticky(pos)
	getactivated=0
	local direction = {x=0, y=0, z=0}
	local lpos=pos

	getactivated=getactivated+mesecon:is_power_off(lpos,  0,  0, -1)
	getactivated=getactivated+mesecon:is_power_off(lpos,  0, -1, -1)
	getactivated=getactivated+mesecon:is_power_off(lpos,  0,  1, -1)

	if getactivated>0 then direction.z=1 return direction end

	getactivated=getactivated+mesecon:is_power_off(lpos,  0,  1,  1)
	getactivated=getactivated+mesecon:is_power_off(lpos,  0, -1,  1)
	getactivated=getactivated+mesecon:is_power_off(lpos,  0,  0,  1)

	if getactivated>0 then direction.z=-1 return direction end

	getactivated=getactivated+mesecon:is_power_off(lpos,  1,  0,  0)
	getactivated=getactivated+mesecon:is_power_off(lpos,  1,  1,  0)
	getactivated=getactivated+mesecon:is_power_off(lpos,  1, -1,  0)

	if getactivated>0 then direction.x=-1 return direction end

	getactivated=getactivated+mesecon:is_power_off(lpos, -1,  1,  0)
	getactivated=getactivated+mesecon:is_power_off(lpos, -1, -1,  0)
	getactivated=getactivated+mesecon:is_power_off(lpos, -1,  0,  0)
	if getactivated>0 then direction.x=1 return direction end
	return direction
end

function mesecon:is_power_off(p, x, y, z)
	local lpos = {}
	lpos.x=p.x+x
	lpos.y=p.y+y
	lpos.z=p.z+z
	local node = minetest.env:get_node(lpos)
	if node.name == "jeija:mesecon_off" then
		return 1
	end
	return 0
end

mesecon:register_on_signal_on(function (pos, node)
	if (node.name=="piston:normal" or node.name=="piston:sticky") then
		local direction=mesecon:piston_get_direction(pos)
		local np = {x=pos.x+direction.x, y=pos.y+direction.y, z=pos.z+direction.z}	
		local coln = minetest.env:get_node(np)
		if coln.name ~= "air" and coln.name ~="water" then
			local thisp= {x=np.x, y=np.y, z=np.z}
			local thisnode=minetest.env:get_node(thisp)
			local nextnode={}
			minetest.env:remove_node(thisp)
			repeat
				thisp.x=thisp.x+direction.x
				thisp.y=thisp.y+direction.y
				thisp.z=thisp.z+direction.z
				nextnode=minetest.env:get_node(thisp)
				minetest.env:add_node(thisp, {name=thisnode.name})
				nodeupdate(thisp)
				thisnode=nextnode
			until thisnode.name=="air" 
			or thisnode.name=="ignore" 
			or thisnode.name=="default:water" 
			or thisnode.name=="default:water_flowing"
		end
	end
end)

mesecon:register_on_signal_off(function (pos, node)
	if node.name=="piston:sticky" then
		local direction=mesecon:piston_get_direction_sticky(pos)
		local np = {x=pos.x+direction.x, y=pos.y+direction.y, z=pos.z+direction.z}	
		local coln = minetest.env:get_node(np)
		if coln.name == "air" or coln.name =="water" then
			local thisp= {x=np.x+direction.x, y=np.y+direction.y, z=np.z+direction.z}
			local thisnode=minetest.env:get_node(thisp)
			if thisnode.name~="air" and thisnode.name~="water" then
				local newpos={}
				local oldpos={}
				repeat
					newpos.x=thisp.x-direction.x
					newpos.y=thisp.y-direction.y
					newpos.z=thisp.z-direction.z
					minetest.env:add_node(newpos, 
					{name=minetest.env:get_node(thisp).name})	
					nodeupdate(newpos)
					oldpos={x=thisp.x, y=thisp.y, z=thisp.z}
					thisp.x=thisp.x+direction.x
					thisp.y=thisp.y+direction.y
					thisp.z=thisp.z+direction.z
					thisnode=minetest.env:get_node(thisp)
				until thisnode.name=="air" 
				or thisnode.name=="ignore" 
				or thisnode.name=="default:water" 
				or thisnode.name=="default:water_flowing"
				minetest.env:remove_node(oldpos)
			end		
		end
	end
end)
