TCLUSTER_TNT_RANGE=5
TCLUSTER_CATAPULT_INTENSITY=5
TCLUSTER_CATAPULT_HIGHT=5

minetest.register_craft({
	output = 'node "tcluster:tnt" 1',
	recipe = {
		{'node "experimental:tnt"','node "experimental:tnt"'},
		{'node "experimental:tnt"','node "experimental:tnt"'},
	}
})
minetest.register_node("tcluster:tnt", {
	tile_images = {"tcluster_tnt_parent_top.png", "tcluster_tnt_parent_bottom.png",
			"tcluster_tnt_parent_side.png", "tcluster_tnt_parent_side.png",
			"tcluster_tnt_parent_side.png", "tcluster_tnt_parent_side.png"},
	inventory_image = minetest.inventorycube("tcluster_tnt_parent_top.png",
			"tcluster_tnt_parent_side.png", "tcluster_tnt_parent_side.png"),
})

minetest.register_on_punchnode(function(p, node)
	if node.name == "tcluster:tnt" then
		minetest.env:remove_node(p)
		minetest.env:add_entity(p, "tcluster:tnt")
		nodeupdate(p)
	end
end)

local TCLUSTER_TNT = {
	-- Static definition
	physical = true, -- Collides with things
	-- weight = 5,
	collisionbox = {-0.5,-0.5,-0.5, 0.5,0.5,0.5},
	visual = "cube",
	textures = {"tcluster_tnt_parent_top.png", "tcluster_tnt_parent_bottom.png",
			"tcluster_tnt_parent_side.png", "tcluster_tnt_parent_side.png",
			"tcluster_tnt_parent_side.png", "tcluster_tnt_parent_side.png"},
	-- Initial value for our timer
	timer = 0,
	-- Number of punches required to defuse
	health = 1,
	blinktimer = 0,
	blinkstatus = true,
}

function TCLUSTER_TNT:on_activate(staticdata)
	self.object:setvelocity({x=0, y=4, z=0})
	self.object:setacceleration({x=0, y=-10, z=0})
	self.object:settexturemod("^[brighten")
end

function TCLUSTER_TNT:on_step(dtime)
	self.timer = self.timer + dtime
	self.blinktimer = self.blinktimer + dtime
    if self.timer>5 then
        self.blinktimer = self.blinktimer + dtime
        if self.timer>8 then
            self.blinktimer = self.blinktimer + dtime
            self.blinktimer = self.blinktimer + dtime
        end
    end
	if self.blinktimer > 0.5 then
		self.blinktimer = self.blinktimer - 0.5
		if self.blinkstatus then
			self.object:settexturemod("")
		else
			self.object:settexturemod("^[brighten")
		end
		self.blinkstatus = not self.blinkstatus
	end
	if self.timer > 10 then
		local pos = self.object:getpos()
        pos.x = math.floor(pos.x+0.5)
        pos.y = math.floor(pos.y+0.5)
        pos.z = math.floor(pos.z+0.5)
        for x=-TCLUSTER_TNT_RANGE,TCLUSTER_TNT_RANGE do
       	for y=-TCLUSTER_TNT_RANGE,TCLUSTER_TNT_RANGE do
       	for z=-TCLUSTER_TNT_RANGE,TCLUSTER_TNT_RANGE do
       	    if x*x+y*y+z*z <= TCLUSTER_TNT_RANGE * TCLUSTER_TNT_RANGE + TCLUSTER_TNT_RANGE then
                local np={x=pos.x+x,y=pos.y+y,z=pos.z+z}
                local n = minetest.env:get_node(np)
                if n.name=="tcluster:tnt" then
			minetest.env:add_entity(np, "tcluster:tnt")
		end
                if n.name ~= "air" then
                	minetest.env:remove_node(np)
		end
            end
        end
        end
        end
	--explodes and spawns more tclustertnts
	local pos=self.object:getpos()
	local pos1, pos2, pos3, pos4
	pos1={x=pos.x-0.4, y=pos.y, z=pos.z-0.4}
	pos2={x=pos.x+0.4, y=pos.y, z=pos.z+0.4}
	pos3={x=pos.x-0.4, y=pos.y, z=pos.z+0.4}
	pos4={x=pos.x+0.4, y=pos.y, z=pos.z-0.4}
	print(pos1.x)
	print(pos1.y)
	print(pos1.z)
	minetest.env:add_entity(pos1, "tcluster:tnt_2state") 
	minetest.env:add_entity(pos2, "tcluster:tnt_2state")
	minetest.env:add_entity(pos3, "tcluster:tnt_2state")
	minetest.env:add_entity(pos4, "tcluster:tnt_2state")
	self.object:remove()
	end
end

function TCLUSTER_TNT:on_punch(hitter)
	self.health = self.health - 1
	if self.health <= 0 then
		self.object:remove()
		hitter:add_to_inventory("node tcluster:tnt 1")
		hitter:set_hp(hitter:get_hp() - 1)
	end
end

--2nd TNT THAT JUMPS OUT OF THE FIRST:

local TCLUSTER_TNT_2STATE = {
	-- Static definition
	physical = true, -- Collides with things
	-- weight = 5,
	collisionbox = {-0.5,-0.5,-0.5, 0.5,0.5,0.5},
	visual = "cube",
	textures = {"tcluster_tnt_top.png", "tcluster_tnt_bottom.png",
			"tcluster_tnt_side.png", "tcluster_tnt_side.png",
			"tcluster_tnt_side.png", "tcluster_tnt_side.png"},
	-- Initial value for our timer
	timer = 0,
	-- Number of punches required to defuse
	health = 1,
	blinktimer = 0,
	blinkstatus = true,
}

function TCLUSTER_TNT_2STATE:on_step(dtime)
	self.timer = self.timer + dtime
	self.blinktimer = self.blinktimer + dtime
    if self.timer>5 then
        self.blinktimer = self.blinktimer + dtime
        if self.timer>8 then
            self.blinktimer = self.blinktimer + dtime
            self.blinktimer = self.blinktimer + dtime
        end
    end
	if self.blinktimer > 0.5 then
		self.blinktimer = self.blinktimer - 0.5
		if self.blinkstatus then
			self.object:settexturemod("")
		else
			self.object:settexturemod("^[brighten")
		end
		self.blinkstatus = not self.blinkstatus
	end
	if self.timer > 4 then
		local pos = self.object:getpos()
        pos.x = math.floor(pos.x+0.5)
        pos.y = math.floor(pos.y+0.5)
        pos.z = math.floor(pos.z+0.5)
        for x=-TCLUSTER_TNT_RANGE,TCLUSTER_TNT_RANGE do
        for y=-TCLUSTER_TNT_RANGE,TCLUSTER_TNT_RANGE do
        for z=-TCLUSTER_TNT_RANGE,TCLUSTER_TNT_RANGE do
            if x*x+y*y+z*z <= TCLUSTER_TNT_RANGE * TCLUSTER_TNT_RANGE + TCLUSTER_TNT_RANGE then
                local np={x=pos.x+x,y=pos.y+y,z=pos.z+z}
                local n = minetest.env:get_node(np)
                if n.name ~= "air" then
                    minetest.env:remove_node(np)
                end
            end
        end
        end
        end
		self.object:remove()
	end
end

function TCLUSTER_TNT_2STATE:on_punch(hitter)
	self.health = self.health - 1
	if self.health <= 0 then
		self.object:remove()
		hitter:add_to_inventory("node tcluster:tnt 1")
		hitter:set_hp(hitter:get_hp() - 1)
	end
end

function TCLUSTER_TNT_2STATE:on_activate(staticdata) -- 2nd tnt that jumps out of the first
	local pos=self.object:getpos()
	print(pos.x)
	print(pos.y)
	print(pos.z)
	local velocity={}
	local xvel=0
	local zvel=0
	if (pos.x-math.floor(pos.x)) > 0.5 then
		print("negative")
		xvel=-1+(pos.x-math.floor(pos.x))*TCLUSTER_CATAPULT_INTENSITY*-1
	else
		xvel=(pos.x-math.floor(pos.x))*TCLUSTER_CATAPULT_INTENSITY
	end

	if (pos.z-math.floor(pos.z)) > 0.5 then
		print("negative")
		zvel=-1+(pos.z-math.floor(pos.z))*TCLUSTER_CATAPULT_INTENSITY*-1
	else
		zvel=(pos.z-math.floor(pos.z))*TCLUSTER_CATAPULT_INTENSITY
	end

	local velocity={x=xvel, y=TCLUSTER_CATAPULT_HIGHT, z=zvel}
	self.object:setvelocity(velocity)
	self.object:setacceleration({x=0, y=-10, z=0})
	self.object:settexturemod("^[brighten")
end




minetest.register_entity("tcluster:tnt", TCLUSTER_TNT)
minetest.register_entity("tcluster:tnt_2state", TCLUSTER_TNT_2STATE)

--REMOVE THIS IF YOU DONT HAVE MESECON MOD INSTALLED
mesecon:register_on_signal_on(function(pos, node)
	if node.name=="tcluster:tnt" then	
		minetest.env:remove_node(pos)
		minetest.env:add_entity(pos, "tcluster:tnt")
		nodeupdate(pos)
	end
end)
