ARROW_DAMAGE=1
ARROW_GRAVITY=9
ARROW_VELOCITY=19

throwing_shoot_arrow=function (item, player, pointed_thing)
	local inventorylist=player:inventory_get_list("main")
	local i=1
	while inventorylist[i]~=nil do
		if string.find(inventorylist[i], "throwing:arrow")~=nil then
			print ("NOW")
			local bnumbeg, bnumend=string.find(inventorylist[i], '" ')
			local oldvalue=tonumber(string.sub(inventorylist[i], bnumend))
			oldvalue=oldvalue-1
			local newstring=string.sub(inventorylist[i], 1, bnumend)
			newstring=(newstring..tostring(oldvalue))
			if oldvalue~= 0 then
				inventorylist[i]=newstring
			else
				inventorylist[i]=""
			end
			player:inventory_set_list("main", inventorylist)

			local playerpos=player:getpos()
			minetest.env:add_entity({x=playerpos.x,y=playerpos.y+1.5,z=playerpos.z}, "throwing:arrow_entity")
			local dir=player:get_look_dir()
			local objs = minetest.env:get_objects_inside_radius({x=playerpos.x,y=playerpos.y,z=playerpos.z}, 2)
			for k, obj in pairs(objs) do
				if obj:get_player_name()==nil then
					obj:setvelocity({x=dir.x*ARROW_VELOCITY, y=dir.y*ARROW_VELOCITY, z=dir.z*ARROW_VELOCITY})
					obj:setacceleration({x=dir.x*-3, y=-ARROW_GRAVITY, z=dir.z*-3})
				end
			end
			break
		end
		i=i+1
	end
	return
end

minetest.register_craftitem("throwing:string", {
	image = "throwing_string.png",
	on_place_on_ground = minetest.craftitem_place_item,
})

minetest.register_craftitem("throwing:bow", {
	image = "throwing_bow.png",
	on_place_on_ground = minetest.craftitem_place_item,
	on_use = throwing_shoot_arrow,
})

minetest.register_craftitem("throwing:arrow", {
	image = "throwing_arrow.png",
	on_place_on_ground = minetest.craftitem_place_item,
})

minetest.register_entity("throwing:arrow_entity", {
	physical = false,
	timer=0,
	textures = {"throwing_arrow_back.png"},
	lastpos={},
	collisionbox = {0,0,0,0,0,0},
	on_step = function(self, dtime)
		self.timer=self.timer+dtime
		local pos = self.object:getpos()
		local node = minetest.env:get_node(pos)
		if self.timer>0.2 then
			local objs = minetest.env:get_objects_inside_radius({x=pos.x,y=pos.y,z=pos.z}, 2)
			for k, obj in pairs(objs) do
				if not (obj:getpos().x==self.object:getpos().x and
				obj:getpos().y==self.object:getpos().y and
				obj:getpos().y==self.object:getpos().y) then
					obj:set_hp(obj:get_hp()-ARROW_DAMAGE)
					if obj:get_hp()<=0 then obj:remove() end
					--self.object:remove() Lua api needs ability to get object name
					return
				end
			end
		end
		if node.name ~= "air" then
			minetest.env:add_item(self.lastpos, 'craft "throwing:arrow" 1')
			self.object:remove()
		end
		self.lastpos={x=pos.x, y=pos.y, z=pos.z}
	end
})

--CRAFTS
minetest.register_craft({
	output = 'craft "throwing:string" 1',
	recipe = {
		{'node "default:junglegrass"'},
		{'node "default:junglegrass"'},
	}
})

minetest.register_craft({
	output = 'craft "throwing:bow" 1',
	recipe = {
		{'craft "throwing:string"', 'node "default:wood"', ''},
		{'craft "throwing:string"', '', 'node "default:wood"'},
		{'craft "throwing:string"', 'node "default:wood"', ''},
	}
})

minetest.register_craft({
	output = 'craft "throwing:arrow" 16',
	recipe = {
		{'craft "default:stick"', 'craft "default:stick"', 'craft "default:steel_ingot"'},
	}
})

print ("[Throwing_mod] Loaded!")
